function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import { Multimap } from '../multimap';
import { ee } from './Bus';
import { CustomEvent } from './CustomEvent';

var CustomEvents = /*#__PURE__*/function () {
  function CustomEvents() {
    _classCallCheck(this, CustomEvents);

    this._types = new Set();
    this._typesByScope = new Multimap();
    this._eventByType = new Map();
    this._componentsByType = new Multimap();
  }

  _createClass(CustomEvents, [{
    key: "events",
    get: function get() {
      return Array.from(this.types);
    }
  }, {
    key: "types",
    get: function get() {
      return this._types;
    }
  }, {
    key: "getScope",
    value: function getScope(type) {
      return this._typesByScope.getKeysForValue(type)[0];
    }
  }, {
    key: "getEvent",
    value: function getEvent(type) {
      return this._eventByType.get(type);
    }
  }, {
    key: "add",
    value: function add(type, e) {
      var log = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var event = e || new CustomEvent(type, log);
      var scope = event.scope || 'component';

      this._types.add(type);

      this._typesByScope.add(scope, type);

      this._eventByType.set(type, event);

      if (scope === 'global') {
        ee.add(type, event.log);
      }
    }
  }, {
    key: "bind",
    value: function bind(type, component, options) {
      var scope = this.getScope(type);
      var event = this.getEvent(type);

      if (scope === 'global') {
        if (!this._componentsByType.getValuesForKey(type).includes(component)) {
          event.bind(component, ee, options);
        }

        this._componentsByType.add(type, component);
      } else {
        event.bind(component, ee, options);
      }
    }
  }, {
    key: "unbind",
    value: function unbind(type, component) {
      var scope = this.getScope(type);
      var event = this.getEvent(type);

      if (scope === 'global') {
        if (this._componentsByType.has(type, component)) {
          event.unbind(component, ee);

          this._componentsByType.delete(type, component);
        }
      } else {
        event.unbind(component, ee);
      }
    }
  }]);

  return CustomEvents;
}();

export var customEvents = new CustomEvents();