function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import { Multimap } from '../multimap';

var Subscriber = /*#__PURE__*/function () {
  function Subscriber(component) {
    _classCallCheck(this, Subscriber);

    this._component = component;
    this._callbacksByName = new Multimap();
  }

  _createClass(Subscriber, [{
    key: "component",
    get: function get() {
      return this._component;
    }
  }, {
    key: "on",
    value: function on(name, cb) {
      this._callbacksByName.add(name, cb);

      return this;
    }
  }, {
    key: "trigger",
    value: function trigger(name) {
      var _this = this;

      for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        params[_key - 1] = arguments[_key];
      }

      this._callbacksByName.getValuesForKey(name).forEach(function (cb) {
        cb.apply.apply(cb, [_this._component].concat(params));
      });
    }
  }]);

  return Subscriber;
}();

var Subscribers = /*#__PURE__*/function () {
  function Subscribers() {
    _classCallCheck(this, Subscribers);

    this._componentsBySlug = new Multimap();
    this._subscribersBySlug = new Multimap();
  }

  _createClass(Subscribers, [{
    key: "add",
    value: function add(component, slug) {
      if (this._componentsBySlug.has(slug, component)) {
        return this._subscribersBySlug.getValuesForKey(slug).filter(function (subscriber) {
          return subscriber.component === component;
        })[0];
      }

      var subscriber = new Subscriber(component);

      this._componentsBySlug.add(slug, component);

      this._subscribersBySlug.add(slug, subscriber);

      return subscriber;
    }
  }, {
    key: "remove",
    value: function remove(component) {
      var _this2 = this;

      if (this._componentsBySlug.hasValue(component)) {
        this._componentsBySlug.getKeysForValue(component).forEach(function (slug) {
          _this2._componentsBySlug.delete(slug, component);

          _this2._subscribersBySlug.getValuesForKey(slug).forEach(function (subscriber) {
            if (subscriber.component === component) {
              _this2._subscribersBySlug.delete(slug, subscriber);
            }
          });
        });
      }
    }
  }, {
    key: "emit",
    value: function emit(component) {
      var slug = component.slug;

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var name = args[0],
          params = args.slice(1);

      if (this._subscribersBySlug.hasKey(slug)) {
        this._subscribersBySlug.getValuesForKey(slug).forEach(function (subscriber) {
          subscriber.trigger(name, params);
        });
      }
    }
  }]);

  return Subscribers;
}();

export var subscribers = new Subscribers();